// override.cpp - LCTextOut
// 2006/09/27

#include "override.h"
#define _GDIPP_DLL
#include "supinfo.h"
#include "ft.h"

#include <malloc.h>		// _alloca
#include <mbctype.h>	// _getmbcp

#pragma comment(lib, "Gdi32.lib")
#pragma comment(lib, "User32.lib")


HFONT GetCurrentFont(HDC hdc)
{
	HFONT hCurFont = (HFONT)GetCurrentObject(hdc, OBJ_FONT);
	if (!hCurFont) {
		// NULL̏ꍇSystemݒ肵Ă
		hCurFont = (HFONT)GetStockObject(SYSTEM_FONT);
	}
	return hCurFont;
}

BOOL IsOutlineFont(HDC hdc)
{
	OUTLINETEXTMETRIC otm = { sizeof(OUTLINETEXTMETRIC) };
	return GetOutlineTextMetrics(hdc, otm.otmSize, &otm);
}

// LDCǂ`FbN
BOOL IsValidDC(HDC hdc)
{
	// v^e
	if (GetDeviceCaps(hdc, TECHNOLOGY) != DT_RASDISPLAY) {
		return FALSE;
	}

	// rbg}bvtHge
	if (!IsOutlineFont(hdc)) {
		return FALSE;
	}

	// ŃtHg`FbNs
	WCHAR szFaceName[LF_FACESIZE] = L"";
	GetTextFaceW(hdc, LF_FACESIZE, szFaceName);
	if (g_pSettings->IsFontExcluded(szFaceName)) {
		return FALSE;
	}
	return TRUE;
}

BOOL IsProcessExcluded()
{
//	if (GetModuleHandle(NULL) == GetModuleHandle(_T("gdi++.exe"))) {
//		return TRUE;
//	}

	STARTUPINFO si = { sizeof(STARTUPINFO) };
	GetStartupInfo(&si);
	if (IsGdiPPStartupInfo(si)) {
		return FALSE;
	}

	if (g_pSettings->IsProcessExcluded()) {
		return TRUE;
	}
	return FALSE;
}

BOOL FreeTypeGetTextExtentPoint(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize);

//؂グZ
int div_ceil(int a, int b)
{
	if(a % b)
		return (a>0)? (a/b+1): (a/b-1);
	return a / b;
}

template <typename _TCHAR, class _Function>
BOOL _GetTextExtentPoint32AorW(HDC hdc, _TCHAR* lpString, int cbString, LPSIZE lpSize, _Function fn)
{
	if (!IsValidDC(hdc) || !lpString || cbString <= 0) {
		return fn(hdc, lpString, cbString, lpSize);
	}

	BOOL b = FALSE;
	b = FreeTypeGetTextExtentPoint(hdc, lpString, cbString, lpSize);
	return b;
}


//firefox
BOOL WINAPI IMPL_GetTextExtentPoint32A(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	return _GetTextExtentPoint32AorW(hdc, lpString, cbString, lpSize, ORIG_GetTextExtentPoint32A);
}

BOOL WINAPI IMPL_GetTextExtentPoint32W(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	return _GetTextExtentPoint32AorW(hdc, lpString, cbString, lpSize, ORIG_GetTextExtentPoint32W);
}

BOOL WINAPI IMPL_GetTextExtentPointA(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	return _GetTextExtentPoint32AorW(hdc, lpString, cbString, lpSize, ORIG_GetTextExtentPoint32A);
}

BOOL WINAPI IMPL_GetTextExtentPointW(HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize)
{
	return _GetTextExtentPoint32AorW(hdc, lpString, cbString, lpSize, ORIG_GetTextExtentPoint32W);
}

BOOL WINAPI IMPL_GetTextMetricsA(HDC hdc, LPTEXTMETRICA lptm)
{
	TEXTMETRICW tmW = { 0 };
	if (!ORIG_GetTextMetricsA(hdc, lptm)
			|| !FreeTypeGetTextMetrics(hdc, &tmW)) {
		return FALSE;
	}
	if (lptm) {
		lptm->tmHeight  = tmW.tmHeight;
		lptm->tmAscent  = tmW.tmAscent;
		lptm->tmDescent = tmW.tmDescent;
	}
	return TRUE;
}

BOOL WINAPI IMPL_GetTextMetricsW(HDC hdc, LPTEXTMETRICW lptm)
{
	return ORIG_GetTextMetricsW(hdc, lptm) && (lptm && FreeTypeGetTextMetrics(hdc, lptm));
}

EXTERN_C BOOL WINAPI GdippInjectDLL(HANDLE process, LPCWSTR app);

//qvZXɂgdi++Kp
BOOL WINAPI IMPL_CreateProcessW(LPCWSTR lpApp, LPWSTR lpCmd, LPSECURITY_ATTRIBUTES pa, LPSECURITY_ATTRIBUTES ta, BOOL bInherit, DWORD dwFlags, LPVOID lpEnv, LPCWSTR lpDir, LPSTARTUPINFOW psi, LPPROCESS_INFORMATION ppi)
{
	if (!g_pSettings->HookChildProcesses() || (!lpApp && !lpCmd) || (dwFlags & (DEBUG_PROCESS | DEBUG_ONLY_THIS_PROCESS))) {
		return ORIG_CreateProcessW(lpApp, lpCmd, pa, ta, bInherit, dwFlags, lpEnv, lpDir, psi, ppi);
	}

	PROCESS_INFORMATION _pi = { 0 };
	if (!ppi) {
		ppi = &_pi;
	}

	const DWORD dwOld = dwFlags;
	dwFlags |= CREATE_SUSPENDED;
	if (!ORIG_CreateProcessW(lpApp, lpCmd, pa, ta, bInherit, dwFlags, lpEnv, lpDir, psi, ppi)) {
		TerminateProcess(ppi->hProcess, -1);
		return FALSE;
	}

	LPWSTR app = (LPWSTR)lpApp;
	if (!lpApp) {
		LPWSTR p, cmd;
		WCHAR c;
		p = cmd = lpCmd;
		if (*p == L'"') {
			c = L'"';
			cmd = ++p;
		} else {
			c = L' ';
		}

		for (p++; *p && *p != c; p++);
		app = (LPWSTR)calloc(sizeof(WCHAR), (p - cmd + 1));
		if (app) {
			memcpy(app, cmd, (p - cmd) * sizeof(WCHAR));
			app[p - cmd] = L'\0';
		}
	}

	if (!app || !GdippInjectDLL(ppi->hProcess, app)) {
		TerminateProcess(ppi->hProcess, -1);
		CloseHandle(ppi->hProcess);
		CloseHandle(ppi->hThread);
		ZeroMemory(ppi, sizeof(*ppi));
		if (app != lpApp) {
			free(app);
		}
		return FALSE;
	}

	if (app != lpApp) {
		free(app);
	}
	if (!(dwOld & CREATE_SUSPENDED)) {
		ResumeThread(ppi->hThread);
	}
	return TRUE;
}

/*
HOOK_DEFINE(user32.dll, DWORD, GetTabbedTextExtentA, (HDC hdc, LPCSTR lpString, int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions), (hdc, lpString, nCount, nTabPositions, lpnTabStopPositions))
HOOK_DEFINE(user32.dll, DWORD, GetTabbedTextExtentW, (HDC hdc, LPCWSTR lpString, int nCount, int nTabPositions, CONST LPINT lpnTabStopPositions), (hdc, lpString, nCount, nTabPositions, lpnTabStopPositions))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentExPointA, (HDC hdc, LPCSTR lpszStr, int cchString, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize), (hdc, lpszStr, cchString, nMaxExtent, lpnFit, lpDx, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentExPointW, (HDC hdc, LPCWSTR lpszStr, int cchString, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize), (hdc, lpszStr, cchString, nMaxExtent, lpnFit, lpDx, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentExPointI, (HDC hdc, LPWORD pgiIn, int cgi, int nMaxExtent, LPINT lpnFit, LPINT lpDx, LPSIZE lpSize), (hdc, pgiIn, cgi, nMaxExtent, lpnFit, lpDx, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPointA, (HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize), (hdc, lpString, cbString, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPointW, (HDC hdc, LPCWSTR lpString, int cbString, LPSIZE lpSize), (hdc, lpString, cbString, lpSize))
HOOK_DEFINE(gdi32.dll, BOOL, GetTextExtentPointI, (HDC hdc, LPWORD pgiIn, int cgi, LPSIZE lpSize), (hdc, pgiIn, cgi, lpSize))
*/


void AddFontToFT(HFONT hf, LPCTSTR lpszFace)
{
	if (hf && lpszFace && !g_pSettings->IsFontExcluded(lpszFace)) {
		g_pSettings->FT_AddFont(lpszFace);
	}
}

HFONT WINAPI IMPL_CreateFontA(int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline, DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision, DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily, LPCSTR  lpszFace)
{
	HFONT hf = ORIG_CreateFontA(nHeight, nWidth, nEscapement, nOrientation, fnWeight, fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision, fdwClipPrecision, fdwQuality, fdwPitchAndFamily, lpszFace);
	if (!lpszFace) {
		return hf;
	}

	LPWSTR lpszFaceW = _StrDupAtoW(lpszFace);
	if (lpszFaceW) {
		AddFontToFT(hf, lpszFaceW);
	}
	free(lpszFaceW);
	return hf;
}

HFONT WINAPI IMPL_CreateFontW(int nHeight, int nWidth, int nEscapement, int nOrientation, int fnWeight, DWORD fdwItalic, DWORD fdwUnderline, DWORD fdwStrikeOut, DWORD fdwCharSet, DWORD fdwOutputPrecision, DWORD fdwClipPrecision, DWORD fdwQuality, DWORD fdwPitchAndFamily, LPCWSTR lpszFace)
{
	HFONT hf = ORIG_CreateFontW(nHeight, nWidth, nEscapement, nOrientation, fnWeight, fdwItalic, fdwUnderline, fdwStrikeOut, fdwCharSet, fdwOutputPrecision, fdwClipPrecision, fdwQuality, fdwPitchAndFamily, lpszFace);
	AddFontToFT(hf, lpszFace);
	return hf;
}

HFONT WINAPI IMPL_CreateFontIndirectA(CONST LOGFONTA *lplf)
{
	LOGFONTA lf;
	lf = *lplf;
	if (wcslen(g_pSettings->GetForceFontName() ) > 0) {
		WideCharToMultiByte(CP_ACP, 0, g_pSettings->GetForceFontName(), -1, lf.lfFaceName, LF_FACESIZE, 0, 0);
	}

	HFONT hf = ORIG_CreateFontIndirectA(&lf);
	if(! &lf) {
		return hf;
	}

	LPWSTR lpszFaceW = _StrDupAtoW(lf.lfFaceName);
	if (lpszFaceW) {
		AddFontToFT(hf, lpszFaceW);
	}
	free(lpszFaceW);
	return hf;

	//HFONT hf = ORIG_CreateFontIndirectA(lplf);
	//if(!lplf) {
	//	return hf;
	//}

	//LPWSTR lpszFaceW = _StrDupAtoW(lplf->lfFaceName);
	//if (lpszFaceW) {
	//	AddFontToFT(hf, lpszFaceW);
	//}
	//free(lpszFaceW);
	//return hf;
}

HFONT WINAPI IMPL_CreateFontIndirectW(CONST LOGFONTW *lplf)
{
	HFONT hf = ORIG_CreateFontIndirectW(lplf);
	if(lplf) {
		AddFontToFT(hf, lplf->lfFaceName);
	}
	return hf;
}

BOOL WINAPI IMPL_DrawStateA(HDC hdc, HBRUSH hbr, DRAWSTATEPROC lpOutputFunc, LPARAM lData, WPARAM wData, int x, int y, int cx, int cy, UINT uFlags)
{
	int cchW;
	LPWSTR lpStringW;

	if(lData && uFlags & DSS_DISABLED) {
		switch(uFlags & 0x0f) {
		case DST_COMPLEX:
			{
			CThreadLocalInfo* pTLInfo = g_TLInfo.GetPtr();
			if(!pTLInfo) {
				return FALSE;
			}

			pTLInfo->InDrawState(TRUE);
			BOOL ret = ORIG_DrawStateA(hdc, hbr, lpOutputFunc, lData, wData, x, y, cx, cy, uFlags);
			pTLInfo->InDrawState(FALSE);
			}
			break;
		case DST_TEXT:
		case DST_PREFIXTEXT:
			lpStringW = _StrDupAtoW((LPCSTR)lData, wData ? wData : -1, &cchW);
			if(lpStringW) {
				BOOL ret = IMPL_DrawStateW(hdc, hbr, lpOutputFunc, (LPARAM)lpStringW, cchW, x, y, cx, cy, uFlags);
				free(lpStringW);
				return ret;
			}
			break;
		}
	}
	return ORIG_DrawStateA(hdc, hbr, lpOutputFunc, lData, wData, x, y, cx, cy, uFlags);
}

//DF`DrawText֓
//DrawText͓ExtTextOutĂ̂ŖȂ
BOOL WINAPI IMPL_DrawStateW(HDC hdc, HBRUSH hbr, DRAWSTATEPROC lpOutputFunc, LPARAM lData, WPARAM wData, int x, int y, int cx, int cy, UINT uFlags)
{
	if(lData && uFlags & DSS_DISABLED) {
		switch(uFlags & 0x0f) {
		case DST_COMPLEX:
			{
			CThreadLocalInfo* pTLInfo = g_TLInfo.GetPtr();
			if(!pTLInfo) {
				return FALSE;
			}

			pTLInfo->InDrawState(TRUE);
			BOOL ret = ORIG_DrawStateW(hdc, hbr, lpOutputFunc, lData, wData, x, y, cx, cy, uFlags);
			pTLInfo->InDrawState(FALSE);
			}
			break;
		case DST_TEXT:
		case DST_PREFIXTEXT:
			{
			//wData==0̎ɕvZ
			//APIƈ-1̎ł͂Ȃ
			if(wData == 0) {
				wData = wcslen((LPCWSTR)lData);
			}
			RECT rect = { x, y, x + 10000, y + 10000 };
			//ǂ3DHighLight̏1px炵3DShadowd˂Ă炵
			int oldbm = SetBkMode(hdc, TRANSPARENT);
			COLORREF oldfg = SetTextColor(hdc, GetSysColor(COLOR_3DHIGHLIGHT));
			//DrawStateDrawTextłprefix̃tOt(API̐݌v_)
			const UINT uDTFlags = DT_SINGLELINE | DT_NOCLIP | (uFlags & DST_PREFIXTEXT ? 0 : DT_NOPREFIX);

			OffsetRect(&rect, 1, 1);
			DrawTextW(hdc, (LPCWSTR)lData, wData, &rect, uDTFlags);
			SetTextColor(hdc, GetSysColor(COLOR_3DSHADOW));
			OffsetRect(&rect, -1, -1);
			DrawTextW(hdc, (LPCWSTR)lData, wData, &rect, uDTFlags);
			SetTextColor(hdc, oldfg);
			SetBkMode(hdc, oldbm);
			}
			return TRUE;
		}
	}
	return ORIG_DrawStateW(hdc, hbr, lpOutputFunc, lData, wData, x, y, cx, cy, uFlags);
}

// Windows 2000p
BOOL WINAPI IMPL_TextOutA(HDC hdc, int nXStart, int nYStart, LPCSTR lpString, UINT cbString)
{
	if (g_pSettings->IsWinXPorLater()) {
		return ORIG_TextOutA(hdc, nXStart, nYStart, lpString, cbString);
	} else {
		return IMPL_ExtTextOutA(hdc, nXStart, nYStart, NULL, NULL, lpString, cbString, NULL);
	}
}

BOOL WINAPI IMPL_TextOutW(HDC hdc, int nXStart, int nYStart, LPCWSTR lpString, UINT cbString)
{
	if (g_pSettings->IsWinXPorLater()) {
		return ORIG_TextOutW(hdc, nXStart, nYStart, lpString, cbString);
	} else {
		return IMPL_ExtTextOutW(hdc, nXStart, nYStart, NULL, NULL, lpString, cbString, NULL);
	}
}

void AnsiDxToUnicodeDx(LPCSTR lpStringA, int cbString, const int* lpDxA, int* lpDxW)
{
	LPCSTR lpEndA = lpStringA + cbString;
	while(lpStringA < lpEndA) {
		*lpDxW = *lpDxA++;
		if(IsDBCSLeadByte(*lpStringA)) {
			*lpDxW += *lpDxA++;
			lpStringA++;
		}
		lpDxW++;
		lpStringA++;
	}
}

// ANSI->UnicodeɕϊExtTextOutWɓExtTextOutAiWindows 2000pj
BOOL WINAPI IMPL_ExtTextOutA(HDC hdc, int nXStart, int nYStart, UINT fuOptions, CONST RECT *lprc, LPCSTR lpString, UINT cbString, CONST INT *lpDx)
{
	if (g_pSettings->IsWinXPorLater()) {
		return ORIG_ExtTextOutA(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
	} else {
		LPWSTR lpszUnicode;
		int bufferLength;
		BOOL result;

		lpszUnicode = _StrDupAtoW(lpString, cbString, &bufferLength);
		if(!lpszUnicode) {
			//s: ꉞIWiɓƂ
			return ORIG_ExtTextOutA(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
		}

		int* lpDxW = NULL;
		if(lpDx && cbString && _getmbcp()) {
			lpDxW = (int*)calloc(sizeof(int), cbString);
			AnsiDxToUnicodeDx(lpString, cbString, lpDx, lpDxW);
			lpDx = lpDxW;
		}

		result = IMPL_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, (LPCWSTR)lpszUnicode, bufferLength, lpDx);
		free(lpszUnicode);
		free(lpDxW);
		return result;
	}
}

LPWSTR _StrDupAtoW(LPCSTR pszMB, int cchMB /*= -1*/, int* pcchWC /*= NULL*/)
{
	int _cchWC;
	if (!pcchWC) {
		pcchWC = &_cchWC;
	}
	*pcchWC = 0;

	if (!pszMB) {
		return NULL;
	}
	if (cchMB == -1) {
		cchMB = strlen(pszMB);
	}
	const int cchWC = MultiByteToWideChar(CP_ACP, 0, pszMB, cchMB, NULL, 0);
	if(cchWC < 0) {
		return NULL;
	}
	LPWSTR pszWC = (LPWSTR)calloc(sizeof(WCHAR), cchWC + 1);
	if (!pszWC) {
		return NULL;
	}
	MultiByteToWideChar(CP_ACP, 0, pszMB, cchMB, pszWC, cchWC);
	pszWC[cchWC] = L'\0';
	*pcchWC = cchWC;
	return pszWC;
}


typedef enum {
	ETOE_OK				= 0,
	ETOE_CREATEDC		= 1,
	ETOE_SETFONT		= 2,
	ETOE_CREATEDIB		= 3,
	ETOE_FREETYPE		= 4,
	ETOE_INVALIDARG		= 11,
	ETOE_ROTATION		= 12,
	ETOE_LARGESIZE		= 13,
	ETOE_INVALIDHDC		= 14,
	ETOE_ROTATEFONT		= 15,
	ETOE_NOAREA			= 16,
	ETOE_GETTEXTEXTENT	= 17,
} ExtTextOut_ErrorCode;

//OhL
#define ETO_TRY()		ExtTextOut_ErrorCode error = ETOE_OK; {
#define ETO_THROW(code)	error = (code); goto _EXCEPTION_THRU
#define ETO_CATCH()		} _EXCEPTION_THRU:


BOOL FreeTypeGetTextExtentPoint(HDC hdc, LPCSTR lpString, int cbString, LPSIZE lpSize)
{
	int cchStringW;
	LPWSTR lpStringW = _StrDupAtoW(lpString, cbString, &cchStringW);
	if(!lpStringW) {
		SetLastError(ERROR_NOT_ENOUGH_MEMORY);
		return FALSE;
	}

	BOOL ret = FreeTypeGetTextExtentPoint(hdc, lpStringW, cchStringW, lpSize);
	free(lpStringW);
	return ret;
}

void DrawStatePrepare(HDC hdc)
{
	HBITMAP hbmpSrc = (HBITMAP)GetCurrentObject(hdc, OBJ_BITMAP);
	if(!hbmpSrc) {
		return;
	}

	BITMAP bm;
	HBITMAP hbmpNew;
	GetObject(hbmpSrc, sizeof(BITMAP), &bm);

	if(bm.bmBitsPixel != 1) {
		return;
	}

	//DrawStateĂяoꍇ
	//hdcɑIĂ锒rbg}bvɏ㏑
	HDC hdcMem = CreateCompatibleDC(NULL);
	{
		HDC hdcScr = GetDC(NULL);
		hbmpNew = CreateCompatibleBitmap(hdcScr, bm.bmWidth, bm.bmHeight);
		ReleaseDC(NULL, hdcScr);
	}
	HBITMAP hbmOrg = SelectBitmap(hdcMem, hbmpNew);
	BitBlt(hdcMem, 0, 0, bm.bmWidth, bm.bmHeight, hdc, 0, 0, SRCCOPY);
	SelectBitmap(hdcMem, hbmOrg);
	SelectBitmap(hdc, hbmpNew);

	//rbg}bvj(Ȃ댯)
	DeleteBitmap(hbmpSrc);
	DeleteDC(hdcMem);
}


class CETOBitmap
{
private:
	CBitmapCache&	m_cache;
	HDC				m_hdc;
	HBITMAP			m_hPrevBmp;
	HBITMAP			m_hBmp;
	BYTE*			m_lpPixels;

public:
	CETOBitmap(CBitmapCache& cache)
		: m_cache(cache)
		, m_hdc(NULL)
		, m_hPrevBmp(NULL)
		, m_hBmp(NULL)
		, m_lpPixels(NULL)
	{
	}
	HDC CreateDC()
	{
		m_hdc = m_cache.CreateDC();
		return m_hdc;
	}
	bool CreateDIBandSelect(int cx, int cy)
	{
		m_hBmp = m_cache.CreateDIB(cx, cy, &m_lpPixels);
		if (!m_hBmp) {
			return false;
		}
		m_hPrevBmp = SelectBitmap(m_hdc, m_hBmp);
		return true;
	}
	void RestoreBitmap()
	{
		if (m_hPrevBmp) {
			SelectBitmap(m_hdc, m_hPrevBmp);
			m_hPrevBmp = NULL;
		}
	}
};

// LCExtTextOutiДj̎
BOOL WINAPI IMPL_ExtTextOutW(HDC hdc, int nXStart, int nYStart, UINT fuOptions, CONST RECT *lprc, LPCWSTR lpString, UINT cbString, CONST INT *lpDx)
{
	CCriticalSectionLockTry __lock;
	if (!__lock.TryEnter()) {
		return ORIG_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
	}
	__lock.Leave();

	CThreadLocalInfo* pTLInfo = g_TLInfo.GetPtr();
	if(!pTLInfo) {
		return ORIG_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
	}

	if(pTLInfo->InDrawState()) {
		DrawStatePrepare(hdc);
	}

	CBitmapCache& cache	= pTLInfo->BitmapCache();
	CETOBitmap bmp(cache);

	HDC		hCanvasDC		= NULL;
	HDC		hBufferDC		= NULL;
	HFONT	hPrevFont		= NULL;

ETO_TRY();

	POINT	curPos = { nXStart, nYStart };
	POINT	destPos;
	SIZE	destSize;
	SIZE	canvasSize;

	HFONT	hCurFont		= NULL;

	UINT	align;
	SIZE	textSize;
	TEXTMETRIC tm = { 0 };
	LOGFONT	lf = { 0 };

	if (!lpString || !cbString) {
		ETO_THROW(ETOE_INVALIDARG);
	}

	if (!IsValidDC(hdc)) {
		ETO_THROW(ETOE_INVALIDHDC);	// hdc is invalid
	}

	hCanvasDC = bmp.CreateDC();
	if(!hCanvasDC) {
		ETO_THROW(ETOE_CREATEDC);
	}

	// get cursor / xform
	align = GetTextAlign(hdc);
	if(align & TA_UPDATECP) {
		GetCurrentPositionEx(hdc, &curPos);
	}

	//copy font
	//tHg̓RXg傫AxGetCurrentObjectGetTextMetricŝ
	//̂1x擾Ďg
	hCurFont = GetCurrentFont(hdc);
	if (!hCurFont) {
		ETO_THROW(ETOE_SETFONT);
	}
	hPrevFont = SelectFont(hCanvasDC, hCurFont);
	GetTextMetrics(hdc, &tm);
	if (!GetObject(hCurFont, sizeof(LOGFONT), &lf)) {
		ETO_THROW(ETOE_SETFONT);
	}

	// FreeTypegǂ̔
	if(!g_pSettings->FT_FontExists(lf.lfFaceName)) {
		ETO_THROW(ETOE_FREETYPE);
	}

	//GetTextExtentPointnSetTextCharacterExtraKvƂ炵
	SetTextCharacterExtra(hCanvasDC, GetTextCharacterExtra(hdc));
	//text size
	if(fuOptions & ETO_GLYPH_INDEX) {
		if(!GetTextExtentPointI(hCanvasDC, (LPWORD)lpString, (int)cbString, &textSize)) {
			ETO_THROW(ETOE_GETTEXTEXTENT);
		}
	} else {
		if(!FreeTypeGetTextExtentPoint(hCanvasDC, lpString, (int)cbString, &textSize)) {
			ETO_THROW(ETOE_GETTEXTEXTENT);
		}
	}
	if(lpDx) {
		textSize.cx = 0;
		if(fuOptions & ETO_PDY) {
			for(UINT i=0; i < cbString; textSize.cx += lpDx[i],i+=2);
		} else {
			for(UINT i=0; i < cbString; textSize.cx += lpDx[i++]);
		}
	}

	// C^bÑXg𑫂(\̖̂OABC
	// Ql: http://bugzilla.mozilla.gr.jp/show_bug.cgi?id=3253
	if (tm.tmItalic) {
		ABC abcWidth={0, 0, 0};
		GetCharABCWidthsW(hdc, lpString[cbString-1], lpString[cbString-1], &abcWidth);
		textSize.cx += tm.tmOverhang - abcWidth.abcC;
	}

	// c̏
	// ܂ĂȂ̂ŁAbIɎg悤ɃG[𓊂
	// if ((lf.lfEscapement % 90) != 0)
	if (lf.lfEscapement != 0) {
		ETO_THROW(ETOE_ROTATEFONT);// rotated font
	}
	//trace(L"OrigTextSize=%d %d\n", textSize.cx, textSize.cy);
	//trace(L"OrigCursor=%d %d\n", curPos.x, curPos.y);

	//rectangle
	{
		RECT rc = { 0 };
		const UINT horiz = align & (TA_LEFT|TA_RIGHT|TA_CENTER);
		const UINT vert  = align & (TA_BASELINE|TA_TOP|TA_BOTTOM);

		switch (horiz) {
		case TA_CENTER:
			rc.left  = curPos.x - div_ceil(textSize.cx, 2);
			rc.right = curPos.x + div_ceil(textSize.cx, 2);
			//no move
			break;
		case TA_RIGHT:
			rc.left  = curPos.x - textSize.cx;
			rc.right = curPos.x;
			curPos.x -= textSize.cx;//move pos
			break;
		default:
			rc.left  = curPos.x;
			rc.right = curPos.x + textSize.cx;
			curPos.x += textSize.cx;//move pos
			break;
		}

		switch (vert) {
		case TA_BASELINE:
			rc.top = curPos.y - tm.tmAscent;
			rc.bottom = curPos.y + tm.tmDescent;
			//trace(L"ascent=%d descent=%d\n", metric.tmAscent, metric.tmDescent);
			break;
		case TA_BOTTOM:
			if (!lprc) {
				rc.top = curPos.y - textSize.cy;
				rc.bottom = curPos.y;
				break;
			}
			//ɗ
		default:
			rc.top = curPos.y;
			rc.bottom = curPos.y + textSize.cy;
			break;
		}

		destPos.x = rc.left;
		destPos.y = rc.top;
		destSize.cx = rc.right - rc.left;
		destSize.cy = rc.bottom - rc.top;
		canvasSize = destSize;
	}

	//trace(L"MovedCursor=%d %d\n", curPos.x, curPos.y);
	//trace(L"TargetRect=%d %d %d %d\n", rc.left, rc.top, rc.right, rc.bottom);
	//trace(L"DestPos=%dx%d Size=%dx%d\n", destPos.x, destPos.y, destSize.cx, destSize.cy);
	//trace(L"CanvasPos=%dx%d Size=%dx%d\n", canvasPos.x, canvasPos.y, canvasSize.cx, canvasSize.cy);

	if(destSize.cx < 1 || destSize.cy < 1) {
		ETO_THROW(ETOE_NOAREA); //throw no area
	}

	//bitmap
	if (!bmp.CreateDIBandSelect(canvasSize.cx, canvasSize.cy)) {
		ETO_THROW(ETOE_CREATEDIB);
	}

	{
		const BOOL fillrect = (lprc && (fuOptions & ETO_OPAQUE));

		//clear bitmap
		if(fillrect || GetBkMode(hdc) == OPAQUE) {
			const COLORREF  bgcolor = GetBkColor(hdc); //ƂwiF
			//DIBڑ
			SetBkMode(hCanvasDC, OPAQUE);
			SetBkColor(hCanvasDC, bgcolor);

			RECT rc = { 0, 0, canvasSize.cx, canvasSize.cy };
			cache.FillSolidRect(bgcolor, &rc);

			if(fillrect) {
				ORIG_ExtTextOutW(hdc, 0,0, ETO_OPAQUE, lprc, NULL, 0, NULL);
			}
		}
		else {
			SetBkMode(hCanvasDC, TRANSPARENT);
			BitBlt(hCanvasDC, 0, 0, destSize.cx, destSize.cy, hdc, destPos.x, destPos.y, SRCCOPY);
		}
	}

	//setup
	SetTextAlign(hCanvasDC, TA_LEFT | TA_TOP);

TRACE(_T("%wc, %d, %dx%d\n"), *lpString, cbString, nXStart, nYStart);
	//textout
	SetTextColor(hCanvasDC, GetTextColor(hdc));
	SetBkMode(hCanvasDC, TRANSPARENT);
	fuOptions &= ~ETO_OPAQUE;
	if(pTLInfo->InDrawState()) {
		SetTextColor(hCanvasDC, GetSysColor(COLOR_3DHIGHLIGHT));
		if (!FreeTypeTextOut(hCanvasDC, cache, lf, 1, 1, lpString, cbString, lpDx)) {
			ETO_THROW(ETOE_FREETYPE);
		}
		SetTextColor(hCanvasDC, GetSysColor(COLOR_3DSHADOW));
	}
	if (!FreeTypeTextOut(hCanvasDC, cache, lf, 0, 0, lpString, cbString, lpDx)) {
		ETO_THROW(ETOE_FREETYPE);
	}

	//blt + clipping
	if(lprc && (fuOptions & ETO_CLIPPED)) {
		//TRACE(_T("ClipRect={%d %d %d %d}, pos = {%d,%d}\n"), lprc->left, lprc->top, lprc->right, lprc->bottom,
		//	nXStart, nYStart);
		//trace(L"ClipRect=%d %d %d %d\n", lprc->left, lprc->top, lprc->right, lprc->bottom);
		const RECT rcBlt = { destPos.x, destPos.y, destPos.x + destSize.cx, destPos.y + destSize.cy };
		RECT rcClip = { 0 };
		IntersectRect(&rcClip, &rcBlt, lprc);
		BitBlt(hdc, rcClip.left, rcClip.top, rcClip.right - rcClip.left, rcClip.bottom - rcClip.top,
				hCanvasDC, rcClip.left - rcBlt.left, rcClip.top - rcBlt.top, SRCCOPY);
	} else {
		BitBlt(hdc, destPos.x, destPos.y, destSize.cx, destSize.cy, hCanvasDC, 0, 0, SRCCOPY);
	}

	if(align & TA_UPDATECP) {
		MoveToEx(hdc, curPos.x, curPos.y, NULL);
	}

ETO_CATCH();
	bmp.RestoreBitmap();
	if(hPrevFont) {
		SelectFont(hCanvasDC, hPrevFont);
	}
	if(error == ETOE_OK) {
		return TRUE;
	}
	return ORIG_ExtTextOutW(hdc, nXStart, nYStart, fuOptions, lprc, lpString, cbString, lpDx);
}
//EOF
