
#pragma once

#include "common.h"
#include "tlsdata.h"

#include "cache.h"
#include "settings.h"


class CThreadLocalInfo
{
private:
	CBitmapCache	m_bmpCache;
	BOOL			m_bInDrawState;

public:
	CThreadLocalInfo()
		: m_bInDrawState(false)
	{
	}

	CBitmapCache& BitmapCache()
	{
		return m_bmpCache;
	}

	void InDrawState(bool b)
	{
		m_bInDrawState = b;
	}
	bool InDrawState() const
	{
		return !!m_bInDrawState;
	}
};

extern CTlsData<CThreadLocalInfo>	g_TLInfo;

BOOL IsProcessExcluded();
FORCEINLINE BOOL IsOSXPorLater()
{
	return g_pSettings->IsWinXPorLater();
}


#define HOOK_DEFINE(dll, rettype, name, argtype, vars) \
	rettype WINAPI ORIG_##name argtype; \
	rettype WINAPI IMPL_##name argtype;
#include "hooklist.h"
#undef HOOK_DEFINE

//EOF
